package Core;

import Cli.Clui;
import Others.Adress;
import User.Manager;

/**
 * Initialize the Foodora System, the Clui and the activeUserContext.
 * We may have as many Main instance as we want to.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class Main {
	
	private static MyFoodora foodora = new MyFoodora();
	
	public Main() {
	}

	public static void main(String[] args)  {
		// TODO Auto-generated method stub
		ActiveUserContext activeUser = new ActiveUserContext(foodora);
		foodora.setMarkupPercentage(0.05);
		foodora.setServiceFee(3.0);
		Clui clui = new Clui(foodora,activeUser);
		
		Manager manager = new Manager(650588938, "ceo", "ceo", "ceo@centrale.supelec.fr", "123456789", new Adress(15.0, 10.0), true, "25/15/1955", "jacquo");
		foodora.addManager(manager);
		
		// clui.executeCommand("runtest scenario/my_foodora.ini");
		// clui.executeCommand("runtest scenario/testScenario1.txt");
		// clui.executeCommand("runtest scenario/testScenario2.txt");
		
		/*
		foodora.addManager(manager);
		foodora.addUser(manager);
		
		manager.addUser(0245, "La tanire", "Lataniere", "contact@lataniere.fr", "1234", new Adress(10.0, 15.0), true,"", "", foodora,User.RESTAURANT,"Moral");
		manager.addUser(045, "henry", "henry", "henry.dupont@hotmail.fr", "124578", new Adress(11.0, 15.2), true, "25/12/1994", "henrynou", foodora, User.CUSTOMER, "Human");
		
		Restaurant resto1 = (Restaurant) foodora.getUserByName("Lataniere", "La tanire");
		Customer custo1 = (Customer) foodora.getUserByName("henry", "henry");
		resto1.addDish("MainDish", "pat", "glutenFree", 4.5);
		resto1.createMeal("MyMeal", "HalfMeal");
		resto1.getMealByName("MyMeal").addDish(resto1.getDishByName("pat"));
		
		custo1.createOrder("myOrder",resto1);
		custo1.getOrderByName("myOrder").add(resto1.getDishByName("pat"));
		custo1.getOrderByName("myOrder").add(resto1.getMealByName("MyMeal"));
		
		clui.executeCommand("login jacquo 123456789");
		clui.executeCommand("registerRestaurant 0123456789 resto resto mail password 0.01,0.02");
		clui.executeCommand("registerCustomer 0123456789 custo custo mail password 0.01,0.02 22/03/1995");
		clui.executeCommand("registerCourier 0123456789 resto1 resto1 mail password 0.01,0.02 22/03/1995");
		*/
		clui.launchClui();
	}

}
