package DeliveryStrategy;

import Core.ContextStrategy;
import Exception.ExceptionUnknownStartegyType;

/**
 * Create a context outside foodora to manager and execute strategyDelivery
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class ContextDeliveryStrategy implements ContextStrategy {

	private StrategyDeliveryPolicy strategy;
	
	public ContextDeliveryStrategy(String strategyName) throws ExceptionUnknownStartegyType {
		setStrategy(strategyName);
	}
	
	@Override
	public void setStrategy(String strategyName) throws ExceptionUnknownStartegyType{
		strategyName = strategyName.toLowerCase().trim();
		switch(strategyName){
		case "fairoccupation":
			strategy = new FairOccupationDelivery();
			break;
		case "fastestdelivery":
			strategy = new FastestDelivery();
			break;
		default:
			throw new ExceptionUnknownStartegyType("Unknown startegy '"+strategyName+"', FairOccupation, FastestDelivery available.");
		}
	}
	
	@Override
	public String toString() {
		return strategy.getNameOfStrategy().toString();
	}

	public StrategyDeliveryPolicy getStrategy() {
		return strategy;
	}

	public void setStrategy(StrategyDeliveryPolicy strategy) {
		this.strategy = strategy;
	}
	
	

}
