package DeliveryStrategy;

import java.util.ArrayList;

import User.Courier;
import User.Customer;
import User.Restaurant;

/**
 * Tend to give equally orders to all Couriers.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class FairOccupationDelivery extends StrategyDeliveryPolicy {



	
	
	public FairOccupationDelivery() {
		super();
		this.setNameOfStrategy("FairOccupation");

	}



	@Override
	public Courier chooseCourier(Restaurant restaurant,Customer customer,ArrayList<Courier> listOfCourier) {
		long minNumberOfRun = 100000;
		Courier courierToChoose = null;
		for(Courier c : listOfCourier){
			if((c.getNbOfOrderOfTheDay() <= minNumberOfRun) & (c.isAvailable() == true)){
				minNumberOfRun = c.getNbOfOrderOfTheDay();
				courierToChoose = c;
			}
		}
		return courierToChoose;
		
	}



}
