package DeliveryStrategy;

import java.util.ArrayList;

import Others.Adress;
import Others.Position;
import User.Courier;
import User.Customer;
import User.Restaurant;

/**
 * Will give the order to the nearest courier.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class FastestDelivery extends StrategyDeliveryPolicy{

	protected String nameOfStrategy;
	
	
	
	
	public FastestDelivery() {
		super();
		this.setNameOfStrategy("FastestDelivery"); 
	}




	@Override
	public Courier chooseCourier(Restaurant restaurant,Customer c,ArrayList<Courier> listOfCourier) {
		Adress adress = c.getAdress();
		Adress adressRestaurant = restaurant.getAdress();
		Courier courierToChoose = null;
		double distanceMin = 100000000;
		for(Courier courier : listOfCourier){
			Position position = courier.getPosition();
			double distance = Math.sqrt( Math.pow((adressRestaurant.getX() - position.getX()), 2) + Math.pow((adressRestaurant.getY() - position.getY()), 2)) + Math.sqrt( Math.pow((adressRestaurant.getX() - adress.getX()), 2) + Math.pow((adressRestaurant.getY() - adress.getY()), 2));
			//System.out.println(distance + " : "+courier.getName() + " - "+courier.getPosition());
			if((distance <= distanceMin)&&(courier.isAvailable())){
				distanceMin = distance;
				courierToChoose = courier;
			}
		}
		return courierToChoose;
		
	}
	
	

}
