package Item;

import Exception.ExceptionUnknownDishType;

/**
 * This factory allow us to create generic type of food as we want to,
 * it's then easy to add a Drink category if we want to.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class FactoryDish {
	public Dish createDish(String typeInMeal, String _name, String _typeOfFood, double _price) throws ExceptionUnknownDishType{
		typeInMeal=typeInMeal.toLowerCase().trim();
		switch(typeInMeal){
		case "dessert":
			return new Dessert(_name,_typeOfFood,_price);
		case "maindish":
			return new MainDish(_name,_typeOfFood,_price);
		case "starter":
			return new Starter(_name,_typeOfFood,_price);
		default:
			throw new ExceptionUnknownDishType("Error, '"+typeInMeal+"' is unkwon, try Dessert, MainDish or Starter.");
		} 
	}
}
