package Item;

import Exception.ExceptionUnknownMealType;

/**
 * This Factory allow Restaurant to create generic Meals.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class FactoryMeal {

	public Meal createMeal(String nameOfMeal, String typeOfMeal) throws ExceptionUnknownMealType{
		typeOfMeal=typeOfMeal.toLowerCase().trim();
		switch(typeOfMeal){
			case "halfmeal":
				return new HalfMeal(nameOfMeal,"unknown");
			case "fullmeal":
				return new FullMeal(nameOfMeal,"unknown");
			default:
				throw new ExceptionUnknownMealType("Error, '"+typeOfMeal+"' is unkwon, try HalfMeal or FullMeal.");
		}
	}

}
