package StrategyProfit;

import Core.MyFoodora;

/**
 * Strategy which focus on the delivery cost.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class TargetProfitDeliveryCost extends StrategyTargetProfitPolicy {

	public TargetProfitDeliveryCost(){
		this.setNameOfStrategy("DeliveryCost");
	}
	
	@Override
	public void chooseTargetProfit(MyFoodora myFoodora, double targetProfit) {
		// TODO Auto-generated method stub
		double lastMonthIncome = myFoodora.getLastMonthIncome();
		int numberOfOrder = myFoodora.getNumberOfOrderLastMonth();
		if(numberOfOrder !=0){
			double newDeliveryCost = myFoodora.getServiceFee() + (lastMonthIncome*myFoodora.getMarkupPercentage()-targetProfit)/numberOfOrder;
			if(newDeliveryCost > 0){
					myFoodora.setDeliveryCost(newDeliveryCost);
			}else{
				System.out.println("Warning, new deliveryCost is negative, aborted. " + newDeliveryCost);
			}
		}
	}

}
