package StrategyProfit;

import Core.MyFoodora;

/**
 * Strategy which focus on the markup.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class TargetProfitMarkup extends StrategyTargetProfitPolicy {
	
	public TargetProfitMarkup(){
		this.setNameOfStrategy("Markup");
	}

	@Override
	public void chooseTargetProfit(MyFoodora myFoodora, double targetProfit) {
		// TODO Auto-generated method stub
		double lastMonthIncome = myFoodora.getLastMonthIncome();
		int numberOfOrder = myFoodora.getNumberOfOrderLastMonth();
		if(lastMonthIncome !=0){
			double newMarkupPercentage = (targetProfit-myFoodora.getServiceFee()*numberOfOrder+myFoodora.getDeliveryCost()*numberOfOrder)/lastMonthIncome;
			if(newMarkupPercentage >0){
				myFoodora.setMarkupPercentage(newMarkupPercentage);
			}else{
				System.out.println("Warning, new markupPercentage is negative, aborted. " + newMarkupPercentage);
			}
		}
	}

}
