package StrategyProfit;

import Core.MyFoodora;

/**
 * Strategy focused on the service fee
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class TargetProfitServiceFee extends StrategyTargetProfitPolicy {
	
	public TargetProfitServiceFee(){
		this.setNameOfStrategy("ServiceFee");
	}

	@Override
	public void chooseTargetProfit(MyFoodora myFoodora, double targetProfit) {
		// TODO Auto-generated method stub
		double lastMonthIncome = myFoodora.getLastMonthIncome();
		int numberOfOrder = myFoodora.getNumberOfOrderLastMonth();
		if(numberOfOrder !=0){
			double newServiceFee = (targetProfit-lastMonthIncome*myFoodora.getMarkupPercentage())/numberOfOrder + myFoodora.getDeliveryCost();
			if(newServiceFee >0){
				myFoodora.setServiceFee(newServiceFee);
			}else{
				System.out.println("Warning, new serviceFee is negative, aborted. " + newServiceFee);
			}
		}else{
			System.out.println("Warning, no orders last month, new strategy can't be calculated");
		}
		
	}

}
