package User;

import Core.MyFoodora;
import Order.Order;
import Others.Adress;
import Others.Position;

/**
 * The Courier deliver the order from the restaurant to the customer.
 * It may accept or decline the deliver.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class Courier extends HumanUser{

	
	private Position position;
	private long nbOfLivraison;
	private boolean available;

	/** CONSTRUCTOR **/
	
	
	public Courier(long phoneNumber, String name, String username, String mail, String password,
			Adress adress, boolean activated, String birthdayDate, String surname) {
		super(phoneNumber, name, username, mail, password, adress, activated, birthdayDate, surname);
		this.position = new Position(this.getAdress().getX(),this.getAdress().getY()); // home first
		this.nbOfLivraison = 0;
		this.available = true;
		this.typeOfUser = COURIER;
	}
	
	public Courier(){
		
	}


	public Position getPosition() {
		//return position;//should be GPS getted
		return new Position(this.getAdress().getX(),this.getAdress().getY());
	}

	

	public void setNbOfLivraison(long nbOfLivraison) {
		this.nbOfLivraison = nbOfLivraison;
	}

	public void setPosition(Position position) {
		this.position = position;
	}

	

	public boolean isAvailable() {
		return available;
	}

	public void setAvailable(boolean available) {
		this.available = available;
	}

	public long getNbOfLivraison() {
		return nbOfLivraison;
	}
	

	public void setAvailable() {
		this.available = true;
	}
	public void setNotAvailable(){
		this.available = false;
	}
	
	public void register(MyFoodora foodora){
		ListUser<Courier> listOfCourier = foodora.getListCourier();
		boolean isIn = false;
		for (Courier c : listOfCourier.getList()) {
			if(c == this){
				isIn = true;
			}
		}
		if(isIn == true){
			System.out.println("You're already register in" + foodora);
		}
		else{
			listOfCourier.addUser(this);
		}
		foodora.setListCourier(listOfCourier);
	}
	
	public void unregister(MyFoodora foodora){
		ListUser<Courier> listOfCourier = foodora.getListCourier();
		boolean isNotIn = true;
		for (Courier c : listOfCourier.getList()) {
			if(c == this){
				isNotIn = false;
			}
		}
		if(isNotIn == true){
			System.out.println("You're already unregister in" + foodora);
		}
		else{
			listOfCourier.removeUser(this);
		}
		foodora.setListCourier(listOfCourier);
	}
	
	
	public void acceptDelivery(Order o){
		if(o.isFinalised()){
			System.out.println("The delivery is already or being done by a courier");
		}
		else{
			o.finalize();
			historic.addOrder(o);
			this.nbOfLivraison++;
			this.setNotAvailable();
			System.out.println(this.getName() + " have accepted the delivery.");
		}
		
	}
	

	public long getNbOfOrderOfTheDay (){
		@SuppressWarnings("deprecation")
		int theDay = new java.util.Date().getDay();
		int theMonth = new java.util.Date().getMonth() +1 ;
		int theYear = new java.util.Date().getYear() + 1900;
		Others.Date date = new Others.Date(theYear,theMonth,theDay);
		long nbOfOrderOfTheDay = 0;
		for(Order order : this.historic.getListOrder()){
			if((order.getDate().getIntDay() == date.getIntDay())&(order.getDate().getIntMonth() == date.getIntMonth())&(order.getDate().getIntYear() == date.getIntYear())){
				nbOfOrderOfTheDay++;
			}
		}
		return nbOfOrderOfTheDay;
	}
	
	
	
	public void refuseDelivery(Order o){
		System.out.println("The courier " + this.name + " has refused the delivery");
	}
	
	@Override
	public String toString(){
		return "Courier : "+name+", position : "+adress+", number of orders done : "+nbOfLivraison+", available : "+available;
	}
	
	@Override
	public int compareTo(User courier){
		if(courier instanceof Courier){
			Courier c = (Courier) courier;
			return (int) c.getNbOfLivraison() - (int) this.getNbOfLivraison();
		}
		return -1;
	}
	
}
