package UserFactoryPattern;

import Exception.ExceptionUnknownTypeOfUser;

/**
 * Context to use user factories.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public abstract class FactoryUserFactory {
	
	public static UserFactory createUserFactory(String typeOfUserFactory) throws ExceptionUnknownTypeOfUser {
		if(typeOfUserFactory == "Human"){
			HumanUserFactory humanUF = new HumanUserFactory();
			return humanUF ;
		}
		else if (typeOfUserFactory == "Moral"){
			MoralUserFactory moralUF = new MoralUserFactory();
			return moralUF ;
		}
		else {
			throw new ExceptionUnknownTypeOfUser("Error, '"+typeOfUserFactory+"' is unkwon, try Human or Moral.");
		}
		
	}

}
