package UserFactoryPattern;

import Exception.ExceptionUnknownTypeOfUser;
import Others.Adress;
import User.Courier;
import User.Customer;
import User.HumanUser;
import User.Manager;
import User.MoralUser;

/**
 * Allow to create human users.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public class HumanUserFactory extends UserFactory{
	
	
	
	@Override
	public HumanUser createHumanUser(long phoneNumber, String name, String username, String mail, String password,
			Adress adress, boolean activated, String birthdayDate, String surname, int typeOfUser) throws ExceptionUnknownTypeOfUser {
		if(typeOfUser == COURIER){
			Courier courier = new Courier(phoneNumber, name, username, mail, password,
			adress, activated, birthdayDate, surname);
			return courier;
		}
		else if (typeOfUser == CUSTOMER){
			Customer customer = new Customer(phoneNumber, name, username, mail, password,
			adress, activated, birthdayDate, surname);
			return customer ;
		}
		else if (typeOfUser == MANAGER){
			Manager manager = new Manager(phoneNumber, name, username, mail, password,
			adress, activated, birthdayDate, surname);
			return manager;
		}
		else {
			throw new ExceptionUnknownTypeOfUser("Error, '"+typeOfUser+"' is unkwon, try Customer" + CUSTOMER +" , Courier : " + COURIER + "or Manager : " + MANAGER);
		}
	}

	@Override
	public MoralUser createMoralUser(long phoneNumber, String name, String username, String mail, String password,
			Adress adress, boolean activated, int typeOfUser) {

		return null;
	}
	


		
	}


