package UserFactoryPattern;


import Exception.ExceptionUnknownTypeOfUser;
import Others.Adress;
import User.HumanUser;
import User.MoralUser;

/**
 * Factory to create factory of abstracted user.
 * 
 * @author Nicolas FLEY et Corentin RAVOUX
 *
 */

public abstract class UserFactory {
	
	public static final int UNKNOWN = 0;
	public static final int COURIER = 1;
	public static final int RESTAURANT = 2;
	public static final int CUSTOMER = 3;
	public static final int MANAGER = 4;
	
	public abstract HumanUser createHumanUser(long phoneNumber, String name, String username, String mail, String password,
			Adress adress, boolean activated, String birthdayDate, String surname,int typeOfUser) throws ExceptionUnknownTypeOfUser;
	public abstract MoralUser createMoralUser(long phoneNumber, String name, String username, String mail, String password,
			Adress adress, boolean activated,int typeOfUser)throws ExceptionUnknownTypeOfUser;

	}


