package test;

import static org.junit.Assert.*;

import java.util.ArrayList;

import org.junit.Test;

import Cards.BasicFidelityCard;
import Cards.LotteryFidelityCard;
import Core.MyFoodora;
import Exception.ExceptionUnknownDishType;
import Exception.ExceptionUnknownStartegyType;
import Exception.ExceptionUnknownTypeOfUser;
import Others.Adress;
import User.Customer;
import User.Manager;
import User.Restaurant;
import User.User;

public class TestCard {
	
	public static final int UNKNOWN = 0;
	public static final int COURIER = 1;
	public static final int RESTAURANT = 2;
	public static final int CUSTOMER = 3;
	public static final int MANAGER = 4;

	@Test
	public void testIDCard() {
		BasicFidelityCard card1 = new BasicFidelityCard();
		BasicFidelityCard card2 = new BasicFidelityCard();
		assertTrue(card1.getId() != card2.getId());
	}
	
	
	@Test
	public void testPointInTheCard() throws ExceptionUnknownStartegyType, ExceptionUnknownDishType, ExceptionUnknownTypeOfUser{
		MyFoodora foodora = new MyFoodora();
		Manager manager = new Manager(0674, "jacques", 	"jacquo", "jacques.martin@hotmail.fr", "123456789", new Adress(15.0, 10.0), true, "25/15/1955", "jacquo");
		manager.addUser(0145, "henry", "henry", "henry.dupont@hotmail.fr", "124578", new Adress(11.0, 15.2), true, "25/12/1994", "henrynou", foodora, User.CUSTOMER, "Human");
		Customer henry = (Customer) foodora.getUserByName("henry", "henry");
		henry.registerFidelityPlan("Point");
		manager.addUser(0245, "La tanire", "Lataniere", "contact@lataniere.fr", "1234", new Adress(10.0, 15.0), true,"1", "1", foodora,RESTAURANT,"Moral");
		manager.addUser(0245, "martin", "martin", "martin.zebre@hotmail.fr", "1234", new Adress(10.0, 18.0), true,"25/12/1945", "martinou", foodora,COURIER,"Human");
		Restaurant resto1 = (Restaurant) foodora.getUserByName("Lataniere", "La tanire");
		resto1.addDish("MainDish", "pat", "glutenfree", 5.0);
		ArrayList<String> command = new ArrayList<String>();
		command.add("pat");
		henry.placeOrder(resto1, "Dish", command, foodora);
		assertTrue(henry.getPointInTheCard() == 1);
	
	}
	
	@Test
	public void testPercentageInTheCard() throws ExceptionUnknownStartegyType, ExceptionUnknownTypeOfUser{
		MyFoodora foodora = new MyFoodora();
		Manager manager = new Manager(0674, "jacques", 	"jacquo", "jacques.martin@hotmail.fr", "123456789", new Adress(15.0, 10.0), true, "25/15/1955", "jacquo");
		manager.addUser(0145, "henry", "henry", "henry.dupont@hotmail.fr", "124578", new Adress(11.0, 15.2), true, "25/12/1994", "henrynou", foodora, User.CUSTOMER, "Human");
		Customer henry = (Customer) foodora.getUserByName("henry", "henry");
		henry.registerFidelityPlan("Lottery");
		manager.setProbabilityOnLoteryCard(henry.getCard(), 0.10);
		assertTrue(((LotteryFidelityCard)henry.getCard()).getPercentage() == 0.10);

	}
	
	@Test
	public void testGetReduction(){
		LotteryFidelityCard card = new LotteryFidelityCard();
		Manager manager = new Manager(0674, "jacques", 	"jacquo", "jacques.martin@hotmail.fr", "123456789", new Adress(15.0, 10.0), true, "25/15/1955", "jacquo");
		manager.setProbabilityOnLoteryCard(card, 1.0);
		boolean chance = card.getReduction();
		assertTrue(chance);
	}

}
