package test;

import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;

import Cli.Clui;
import Core.ActiveUserContext;
import Core.MyFoodora;
import Exception.ExceptionUnknownStartegyType;
import Others.Adress;
import User.Manager;


public class TestCli {

	@Rule
	public final ExpectedException exception = ExpectedException.none();
	
	@Test
	public void testClui() throws ExceptionUnknownStartegyType{
		MyFoodora foodora = null;
		foodora = new MyFoodora();
		ActiveUserContext activeUser = new ActiveUserContext(foodora);
		Clui clui = new Clui(foodora,activeUser);
		Manager manager = new Manager(650588938, "ceo", "ceo", "ceo@centrale.supelec.fr", "123456789", new Adress(15.0, 10.0), true, "25/15/1955", "jacquo");
		foodora.addManager(manager);
		clui.executeCommand("login ceo 123456789");
		assert(activeUser.getUser() == manager);
	}
	/*
	@Test
	public void testTokenWrongFormat() {
		exception.expect(errorWrongFormatValue.class);
		MyFoodora foodora = null;
		foodora = new MyFoodora();
		ActiveUserContext activeUser = new ActiveUserContext(foodora);
		Clui clui = new Clui(foodora,activeUser);
		Manager manager = new Manager(650588938, "ceo", "ceo", "ceo@centrale.supelec.fr", "123456789", new Adress(15.0, 10.0), true, "25/15/1955", "jacquo");
		foodora.addManager(manager);
		clui.executeCommand("login ceo 123456789");
		clui.executeCommand("registerCustomer 943684597 Jacques custo_jacques jacques@mail.fr jacques_pwd -9.8 23/02/1975");
	}
	*/
}
