package test;

import static org.junit.Assert.*;

import org.junit.Test;

import Core.MyFoodora;
import DeliveryStrategy.ContextDeliveryStrategy;
import Exception.ExceptionUnknownDishType;
import Exception.ExceptionUnknownMealType;
import Exception.ExceptionUnknownStartegyType;
import Exception.ExceptionUnknownTypeOfUser;
import Item.Dish;
import Item.FactoryDish;
import Item.FactoryMeal;
import Item.Meal;
import Others.Adress;
import StrategyProfit.ContextTargetProfitStrategy;
import User.Manager;

public class TestException {
	
	public static final int UNKNOWN = 0;
	public static final int COURIER = 1;
	public static final int RESTAURANT = 2;
	public static final int CUSTOMER = 3;
	public static final int MANAGER = 4; 
	@Test
	public void testExceptionUnknownDishType() {
		try{
			FactoryDish factory1 = new FactoryDish();
			Dish dish = factory1.createDish("Error", "pat", "glutenfree", 4.5);
		}
		catch (ExceptionUnknownDishType e) {
			assertTrue(true);
		}
	
	}
	
	@Test
	public void testExceptionUnknownMealType(){
		try {
			FactoryMeal factory = new FactoryMeal();
			Meal meal = factory.createMeal("meal1", "eror");
			
		} catch (ExceptionUnknownMealType e) {
			assertTrue(true);
		}
	}
	
	@Test
	public void testExceptionUnknownStartegyDelivery(){
		try{
			MyFoodora foodora = new MyFoodora();
			ContextDeliveryStrategy newStrategy = new ContextDeliveryStrategy("eror");
			foodora.setContextDeliveryPolicy(newStrategy);
		}
		catch (ExceptionUnknownStartegyType e) {
			assertTrue(true);
		}
	}
	
	@Test
	public void testExceptionUnknownStartegyProfit(){
		try{
			MyFoodora foodora = new MyFoodora();
			ContextTargetProfitStrategy newStrategy = new ContextTargetProfitStrategy("eror");
			foodora.setContextTargetProfitStrategy(newStrategy);
		}
		catch (ExceptionUnknownStartegyType e) {
			assertTrue(true);
		}
	}
	
	@Test 
	public void testExceptionUnknownTypeOfUser() throws ExceptionUnknownStartegyType, ExceptionUnknownTypeOfUser{
		MyFoodora foodora = new MyFoodora();
		Manager manager = new Manager(0674, "jacques", 	"jacquo", "jacques.martin@hotmail.fr", "123456789", new Adress(15.0, 10.0), true, "25/15/1955", "jacquo");
		try { manager.addUser(0145, "henry", "henry", "henry.dupont@hotmail.fr", "124578", new Adress(11.0, 15.2), true, "25/12/1994", "henrynou", foodora, CUSTOMER, "error");
		}
		catch (ExceptionUnknownTypeOfUser e) {
			assertTrue(true);
		}
		
		try { manager.addUser(0145, "henry", "henry", "henry.dupont@hotmail.fr", "124578", new Adress(11.0, 15.2), true, "25/12/1994", "henrynou", foodora, 25, "Human");
		}
		catch (ExceptionUnknownTypeOfUser e) {
			assertTrue(true);
		}
		
		try { manager.addUser(0245, "La tanire", "Lataniere", "contact@lataniere.fr", "1234", new Adress(10.0, 15.0), true,"1", "1", foodora,RESTAURANT,"eror");

		}
		catch (ExceptionUnknownTypeOfUser e) {
			assertTrue(true);
		}
		try { manager.addUser(0245, "La tanire", "Lataniere", "contact@lataniere.fr", "1234", new Adress(10.0, 15.0), true,"1", "1", foodora,75,"Moral");

		}
		catch (ExceptionUnknownTypeOfUser e) {
			assertTrue(true);
		}
	}
		

}
