package test;

import static org.junit.Assert.*;

import java.util.ArrayList;

import org.junit.Test;

import Exception.ExceptionUnknownDishType;
import Exception.ExceptionUnknownMealType;
import Item.Dish;
import Item.FactoryDish;
import Item.FactoryMeal;
import Item.Meal;
import Order.HistoricOrder;
import Order.Order;
import Others.Adress;
import Others.Date;
import Others.Period;
import User.Restaurant;

public class TestOrder {

	@Test
	public void testFinalize() {
		Order order = new Order();
		order.finalize();
		int theDay = new java.util.Date().getDay();
		assertTrue(order.getDate().getIntDay() == theDay);
		assertTrue(order.isFinalised());
	}
	
	@Test
	public void testGetListOfOrderInAPeriod(){
		Order order = new Order();
		Order order2 = new Order();
		order.setDate(new Date(2017, 04, 25));
		order2.setDate(new Date(2017, 05, 25));
		Date end = new Date(2017, 05, 05);
		Date begin = new Date(2017, 04, 01);
		Period period = new Period(begin, end);
		HistoricOrder listOfOrder = new HistoricOrder();
		listOfOrder.addOrder(order2);
		listOfOrder.addOrder(order);
		ArrayList<Order> listOfOrderInThePeriod = Order.getListOfOrderInAPeriod(listOfOrder, period);
		assertTrue(listOfOrderInThePeriod.size() == 1);
	}
	
	@Test
	public void testGetPrice() throws ExceptionUnknownMealType, ExceptionUnknownDishType{
		Order order = new Order();
		Restaurant resto = new Restaurant(0245, "La tanire", "Lataniere", "contact@lataniere.fr", "1234", new Adress(10.0, 15.0), true);
		order.setRestaurantAttached(resto);
		FactoryMeal factory = new FactoryMeal();
		Meal meal = factory.createMeal("meal1", "FullMeal");
		FactoryDish factory1 = new FactoryDish();
		Dish dish = factory1.createDish("Dessert", "pat", "glutenfree", 4.5);
		Dish dish2 = factory1.createDish("MainDish", "boulgour", "glutenfree", 5.5);
		Dish dish3 = factory1.createDish("Starter", "soupe", "glutenfree", 5);
		meal.addDish(dish3);
		meal.addDish(dish2);
		meal.addDish(dish);
		order.add(meal);
		order.add(dish3);
		assertTrue(order.getPrice() == 19.25);
		
		
	}

}
