package test;

import static org.junit.Assert.*;

import org.junit.Test;


import Exception.ExceptionUnknownTypeOfUser;
import Others.Adress;
import User.HumanUser;
import User.MoralUser;
import UserFactoryPattern.FactoryUserFactory;
import UserFactoryPattern.UserFactory;

public class TestUserFactory {
	
	public static final int UNKNOWN = 0;
	public static final int COURIER = 1;
	public static final int RESTAURANT = 2;
	public static final int CUSTOMER = 3;
	public static final int MANAGER = 4;

	@Test
	public void testCreateHumanUser() throws ExceptionUnknownTypeOfUser {
		UserFactory factory = FactoryUserFactory.createUserFactory("Human") ;
		HumanUser manager = factory.createHumanUser(0674, "jacques", "jacquo", "jacques.martin@hotmail.fr", "123456789", new Adress(15.0, 10.0), true, "25/15/1955", "jacquo", MANAGER );
		assertTrue(manager.getTypeOfUser() == MANAGER);
		assertTrue(manager.getName()=="jacques");
	}
	
	
	@Test
	public void testCreateMoralUser() throws ExceptionUnknownTypeOfUser {
		UserFactory factory = FactoryUserFactory.createUserFactory("Moral") ;
		MoralUser manager = factory.createMoralUser(0245, "La tanire", "Lataniere", "contact@lataniere.fr", "1234", new Adress(10.0, 15.0), true,RESTAURANT);
		assertTrue(manager.getTypeOfUser() == RESTAURANT);
		assertTrue(manager.getName()=="La tanire");
	}
	

}
